// Trace tests.
// Because tracing is done at runtime we can easily write a test for it. These are some fairly trivial tests to make sure nothing major is broken.

caterwaul.test(function () {
  var observed_trees  = [];
  var observed_values = [];
  var tree_stack      = [];
  var last            = function (xs) {return xs[xs.length - 1]};

  var t = caterwaul.tracer(function (t)    {tree_stack.push(t); observed_trees.push(t)},
                           function (t, v) {tree_stack.pop() -should_be- t; observed_values.push(v)});

  tree_stack.length -should_be- 0;

  var f = function (x) {return x};
  var traced_f = t(f);
  traced_f(5);

  tree_stack.length            -should_be- 0;
  observed_values[0]           -should_be- traced_f;
  observed_values[1]           -should_be- 5;
  observed_trees[0].toString() -should_be- caterwaul.parse(f).toString();
  observed_trees[1].toString() -should_be- caterwaul.parse('x').toString();
  observed_values.length       -should_be- 2;
  observed_trees.length        -should_be- 2;

  // Next step. Make sure Caterwaul can compile its own very gnarly parse() function.
  // This function won't work, but it should compile at least.
  t(caterwaul.parse);
});
// Generated by SDoc 
